## gimagereader 3.1.2+git368fa8f

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
LIST(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
INCLUDE(GSettings)
SET(ENV{LC_ALL} "C")

# Project properties
PROJECT(gimagereader)
SET(PACKAGE_NAME gImageReader)
SET(PACKAGE_VERSION 3.1.2)
SET(PACKAGE_LOCALE_DIR "${CMAKE_INSTALL_PREFIX}/share/locale")

# Variables
SET(INTERFACE_TYPE "qt4" CACHE STRING "Select interface type: qt4/qt5/gtk")
MESSAGE(STATUS "${INTERFACE_TYPE} interface will be built")
SET(MANUAL_DIR "share/doc/gimagereader" CACHE PATH "Path where manual will be installed")
SET(ENABLE_VERSIONCHECK 1 CACHE BOOL "Enable version check")
EXECUTE_PROCESS(COMMAND date +%a\ %b\ %d\ %Y OUTPUT_VARIABLE PACKAGE_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
EXECUTE_PROCESS(COMMAND date -R OUTPUT_VARIABLE PACKAGE_RFC_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
EXECUTE_PROCESS(COMMAND git rev-parse HEAD OUTPUT_VARIABLE PACKAGE_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE)

IF(NOT IS_ABSOLUTE "${MANUAL_DIR}")
    SET(MANUAL_DIR "${CMAKE_INSTALL_PREFIX}/${MANUAL_DIR}")
ENDIF()


# Configure files
CONFIGURE_FILE(data/gimagereader.appdata.xml.in data/gimagereader-${INTERFACE_TYPE}.appdata.xml @ONLY)
CONFIGURE_FILE(data/gimagereader.desktop.in data/gimagereader-${INTERFACE_TYPE}.desktop @ONLY)
CONFIGURE_FILE(packaging/gimagereader.spec.in packaging/gimagereader.spec @ONLY)
CONFIGURE_FILE(packaging/debian/changelog.in packaging/debian/changelog @ONLY)

FILE(GLOB gimagereader_HTML RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} data/manual*.html.in)
SET(manualFiles)
FOREACH(inFile ${gimagereader_HTML})
    STRING(REGEX REPLACE ".in\$" "" outFile "${inFile}")
    CONFIGURE_FILE(${inFile} ${outFile} @ONLY)
    SET(manualFiles ${manualFiles} "${CMAKE_CURRENT_BINARY_DIR}/${outFile}")
ENDFOREACH()


# Definitions
ADD_DEFINITIONS(-DPACKAGE_NAME=\"${PACKAGE_NAME}\")
ADD_DEFINITIONS(-DPACKAGE_VERSION=\"${PACKAGE_VERSION}\")
ADD_DEFINITIONS(-DPACKAGE_REVISION=\"${PACKAGE_REVISION}\")
ADD_DEFINITIONS(-DGETTEXT_PACKAGE=\"${CMAKE_PROJECT_NAME}\")
ADD_DEFINITIONS(-DENABLE_VERSIONCHECK=${ENABLE_VERSIONCHECK})
ADD_DEFINITIONS(-DMANUAL_DIR=\"${MANUAL_DIR}\")
ADD_DEFINITIONS(-std=c++11)

# Dependencies
FIND_PACKAGE(Gettext REQUIRED)
FIND_PACKAGE(PkgConfig REQUIRED)
PKG_CHECK_MODULES(TESSERACT tesseract)
IF(NOT TESSERACT_FOUND)
    MESSAGE(WANING "Using hardcoded tesseract cflags and libs")
    SET(TESSERACT_INCLUDE_DIRS /usr/include/tesseract)
    SET(TESSERACT_LDFLAGS -ltesseract)
ENDIF(NOT TESSERACT_FOUND)
IF(UNIX)
    PKG_CHECK_MODULES(SANE sane-backends)
ENDIF(UNIX)

INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR} ${TESSERACT_INCLUDE_DIRS} ${SANE_INCLUDE_DIRS})

IF("${INTERFACE_TYPE}" STREQUAL "gtk")
    PKG_CHECK_MODULES(GTKMM REQUIRED gtkmm-3.0)
    PKG_CHECK_MODULES(GTKSOURCEVIEWMM REQUIRED gtksourceviewmm-3.0)
    PKG_CHECK_MODULES(GTKSPELLMM REQUIRED gtkspellmm-3.0)
    PKG_CHECK_MODULES(CAIROMM REQUIRED cairomm-1.0)
    PKG_CHECK_MODULES(POPPLER REQUIRED poppler-glib)
    INCLUDE_DIRECTORIES(
        ${GTKMM_INCLUDE_DIRS}
        ${GTKSOURCEVIEWMM_INCLUDE_DIRS}
        ${GTKSPELLMM_INCLUDE_DIRS}
        ${CAIROMM_INCLUDE_DIRS}
        ${POPPLER_INCLUDE_DIRS}
    )
    SET(gimagereader_LIBS
        ${GTKMM_LDFLAGS}
        ${GTKSOURCEVIEWMM_LDFLAGS}
        ${GTKSPELLMM_LDFLAGS}
        ${CAIROMM_LDFLAGS}
        ${POPPLER_LDFLAGS}
    )
    SET(srcdir "gtk")
ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt4")
    SET(CMAKE_AUTOMOC ON)
    FIND_PACKAGE(Qt4 REQUIRED)
    PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt4)
    PKG_CHECK_MODULES(POPPLER REQUIRED poppler-qt4)
    INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS})
    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS})
    SET(srcdir "qt")
ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
    SET(CMAKE_AUTOMOC ON)
    FIND_PACKAGE(Qt5Widgets REQUIRED)
    PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt5)
    PKG_CHECK_MODULES(POPPLER REQUIRED poppler-qt5)
    INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS})
    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS})
    SET(srcdir "qt")
ELSE()
    MESSAGE(FATAL_ERROR "Invalid interface type ${INTERFACE_TYPE}")
ENDIF()

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/${srcdir}/src/ )


# Files
FILE(GLOB gimagereader_SRCS ${srcdir}/src/*.cc)
FILE(GLOB gimagereader_HDRS ${srcdir}/src/*.hh)
FILE(GLOB gimagereader_FORMS ${srcdir}/data/*.ui)
FILE(GLOB gimagereader_ICONS data/icons/*.png)
FILE(GLOB gimagereader_PO po/*.po)
IF("${srcdir}" STREQUAL "qt")
    FILE(GLOB gimagereader_RESOURCES qt/data/*.qrc)
ENDIF()
IF(UNIX)
    LIST(APPEND gimagereader_SRCS ${srcdir}/src/scanner/ScannerSane.cc)
    LIST(APPEND gimagereader_HDRS ${srcdir}/src/scanner/ScannerSane.hh)
ELSE(UNIX)
    LIST(APPEND gimagereader_SRCS ${srcdir}/src/scanner/ScannerTwain.cc)
    LIST(APPEND gimagereader_HDRS ${srcdir}/src/scanner/ScannerTwain.hh)
ENDIF(UNIX)


IF("${srcdir}" STREQUAL "gtk")
    ADD_SCHEMA("gtk/data/org.gnome.gimagereader.gschema.xml")
    ADD_CUSTOM_COMMAND(
        OUTPUT gimagereader.gresource.c
        COMMAND glib-compile-resources gimagereader.gresource.xml --target=${CMAKE_CURRENT_BINARY_DIR}/gimagereader.gresource.c --generate-source
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/gtk/data/
        DEPENDS ${CMAKE_SOURCE_DIR}/gtk/data/gimagereader.gresource.xml
                ${CMAKE_SOURCE_DIR}/gtk/data/gimagereader.ui
                ${CMAKE_SOURCE_DIR}/gtk/data/crashhandler.ui
                ${CMAKE_SOURCE_DIR}/gtk/data/appmenu.ui)
    LIST(APPEND gimagereader_SRCS gimagereader.gresource.c)
ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt4")
    QT4_WRAP_UI(gimagereader_FORMS_HEADERS ${gimagereader_FORMS})
    QT4_ADD_RESOURCES(gimagereader_RESOURCES_RCC ${gimagereader_RESOURCES})
ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
    QT5_WRAP_UI(gimagereader_FORMS_HEADERS ${gimagereader_FORMS})
    QT5_ADD_RESOURCES(gimagereader_RESOURCES_RCC ${gimagereader_RESOURCES})
ENDIF()

IF("${srcdir}" STREQUAL "qt")
    # Gettextize ui files
    ADD_CUSTOM_TARGET(
        gettextizeui
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_SOURCE_DIR}/cmake/gettextizeui.cmake ${gimagereader_FORMS_HEADERS}
        DEPENDS ${gimagereader_FORMS_HEADERS}
    )
ENDIF()

FILE(READ po/LINGUAS langs_string)
STRING(REGEX MATCHALL "[a-zA-Z_]+" langs "${langs_string}")
FILE(COPY ${gimagereader_PO} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
GETTEXT_PROCESS_POT_FILE(po/gimagereader.pot ALL INSTALL_DESTINATION ${PACKAGE_LOCALE_DIR} LANGUAGES ${langs})

IF(MINGW)
  ENABLE_LANGUAGE(RC)
  SET(CMAKE_RC_COMPILER_INIT ${CMAKE_GENERATOR_RC})
  SET(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> -O coff -i <SOURCE> -o <OBJECT>")
  SET(gimagereader_SRCS ${gimagereader_SRCS} packaging/win32/gimagereader-icon.rc)
  LIST(APPEND gimagereader_LIBS -lintl -mwindows)
ENDIF(MINGW)


# Build and install
IF("${srcdir}" STREQUAL "qt")
    STRING(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
    IF(NOT CMAKE_BUILD_TYPE_TOLOWER MATCHES "debug")
        ADD_DEFINITIONS(-DQT_NO_DEBUG_OUTPUT)
    ENDIF()
ENDIF()

ADD_EXECUTABLE(gimagereader
    ${gimagereader_HDRS}
    ${gimagereader_SRCS}
    ${gimagereader_FORMS_HEADERS}
    ${gimagereader_RESOURCES_RCC}
)
TARGET_LINK_LIBRARIES(gimagereader
    ${TESSERACT_LDFLAGS}
    ${gimagereader_LIBS}
    ${SANE_LDFLAGS}
    -ldl
    -lgomp
)
SET_TARGET_PROPERTIES(gimagereader PROPERTIES COMPILE_FLAGS "-fopenmp")
SET_TARGET_PROPERTIES(gimagereader PROPERTIES OUTPUT_NAME gimagereader-${INTERFACE_TYPE})
IF("${INTERFACE_TYPE}" STREQUAL "qt4")
    QT4_USE_MODULES(gimagereader Core Gui Network DBus)
    ADD_DEPENDENCIES(gimagereader gettextizeui)
ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
    QT5_USE_MODULES(gimagereader Widgets Network DBus)
    ADD_DEPENDENCIES(gimagereader gettextizeui)
ENDIF()

INSTALL(TARGETS gimagereader DESTINATION bin)
INSTALL(FILES data/icons/48x48/gimagereader.png DESTINATION share/icons/hicolor/48x48/apps/)
INSTALL(FILES data/icons/128x128/gimagereader.png DESTINATION share/icons/hicolor/128x128/apps/)
INSTALL(FILES data/icons/256x256/gimagereader.png DESTINATION share/icons/hicolor/256x256/apps/)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/data/gimagereader-${INTERFACE_TYPE}.appdata.xml DESTINATION share/appdata)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/data/gimagereader-${INTERFACE_TYPE}.desktop DESTINATION share/applications)
INSTALL(FILES ${manualFiles} DESTINATION "${MANUAL_DIR}")


# Dist
ADD_CUSTOM_TARGET(dist
    COMMAND git archive --format=tar --prefix=${CMAKE_PROJECT_NAME}-${PACKAGE_VERSION}/ HEAD | xz > ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}-${PACKAGE_VERSION}.tar.xz
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

## gimagereader 2.93

=== debian/changelog ===
gimagereader (2.93-2) unstable; urgency=low

  * Fix build failure on Hurd and kFreeBSD due to missing check in configure.ac
  * Bump Standards-Version to 3.9.6 (no changes necessary)

 -- Philip Rinn <rinni@inventati.org>  Mon, 06 Oct 2014 21:01:23 +0200

gimagereader (2.93-1) unstable; urgency=low

  * Initial release (closes: #748350)

 -- Philip Rinn <rinni@inventati.org>  Wed, 20 Aug 2014 00:12:16 +0200

=== debian/control ===
Source: gimagereader
Section: graphics
Priority: optional
Maintainer: Philip Rinn <rinni@inventati.org>
Build-Depends: debhelper (>= 9), dh-autoreconf, autoconf-archive,
 intltool (>= 0.35.0), libgtkspellmm-3.0-dev, libgtkmm-3.0-dev,
 libcairomm-1.0-dev, libpoppler-glib-dev, libtesseract-dev, libsane-dev
Standards-Version: 3.9.6
Homepage: https://github.com/manisandro/gImageReader
Vcs-Git: git://anonscm.debian.org/collab-maint/gimagereader.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/gimagereader.git;a=summary

Package: gimagereader
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Graphical GTK+ front-end to tesseract-ocr
 gImageReader is a simple GTK+ front-end to tesseract-ocr. Tesseract is probably
 the most accurate open source optial character recognition (OCR) sotfware and
 can recognize text in over 60 languages.
 .
 gImageReader supports automatic page layout detection but the user can also
 manually define and adjust the recognition regions. It is possible to import
 images from disk, scanning devices, clipboard and screenshots. gImageReader
 also supports multipage PDF documents. Recognized text is displayed directly
 next to the image and basic text editing including search/replace and removing
 of line breaks is possible. Spellchecking for the output text is also supported
 if the corresponding dictionaries are installed.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
export V=1

## Enable compiler hardening flags.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with autoreconf --parallel

override_dh_auto_configure:
	dh_auto_configure -- --disable-versioncheck

## gimagereader 3.1

=== debian/changelog ===
gimagereader (3.1-1build1) wily; urgency=medium

  * No-change rebuild against libglibmm-2.4-1v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 07 Aug 2015 21:37:00 +0000

gimagereader (3.1-1) unstable; urgency=medium

  * new upstream version
  * add build dependency: libgtksourceviewmm-3.0-dev
  * drop patch debian/patches/01-desktop-entry-lacks-keywords-entry.patch
    - applied upstream
  * add patch debian/patches/01-fix_build_on_armel.patch:
    - fix build failure on armel
  * debian/control: update Vcs-Browser field to use new URL syntax
  * update debian/copyright

 -- Philip Rinn <rinni@inventati.org>  Tue, 12 May 2015 23:15:14 +0200

gimagereader (3.0.1-1) unstable; urgency=low

  * new upstream version
  * drop patch debian/patches/02-detect-sane-on-hurd-and-kfreebsd.patch
    - build system switched to cmake
  * register documentation with doc-base

 -- Philip Rinn <rinni@inventati.org>  Mon, 20 Apr 2015 00:15:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: gimagereader
 Section: graphics
 Priority: optional
-Maintainer: Philip Rinn <rinni@inventati.org>
-Build-Depends: debhelper (>= 9), dh-autoreconf, autoconf-archive,
- intltool (>= 0.35.0), libgtkspellmm-3.0-dev, libgtkmm-3.0-dev,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Philip Rinn <rinni@inventati.org>
+Build-Depends: debhelper (>= 9), cmake, intltool (>= 0.35.0),
+ libgtkspellmm-3.0-dev, libgtkmm-3.0-dev,  libgtksourceviewmm-3.0-dev,
  libcairomm-1.0-dev, libpoppler-glib-dev, libtesseract-dev, libsane-dev
 Standards-Version: 3.9.6
 Homepage: https://github.com/manisandro/gImageReader
 Vcs-Git: git://anonscm.debian.org/collab-maint/gimagereader.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/gimagereader.git;a=summary
+Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/gimagereader.git
 
 Package: gimagereader
 Architecture: any

## gimagereader 3.1.2

=== debian/changelog ===
gimagereader (3.1.2-1build1) wily; urgency=medium

  * No-change rebuild for libstdc++ ABI changes.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Sep 2015 16:13:31 +0200

gimagereader (3.1.2-1) unstable; urgency=medium

  * new upstream version (closes: #785656, #794489)
  * update debian/copyright
  * fix spelling errors in debian/control

 -- Philip Rinn <rinni@inventati.org>  Fri, 14 Aug 2015 16:29:02 +0200

## gimagereader 3.1.2+git368fa8f

=== debian/changelog ===
gimagereader (3.1.2+git368fa8f-2build1) xenial; urgency=medium

  * No-change rebuild against libtesseract3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Apr 2016 00:29:07 +0000

gimagereader (3.1.2+git368fa8f-2) unstable; urgency=medium

  * add debian/patches/02-make_build_reproducible.patch:
    - make build reproducible
  * Bump Standards-Version to 3.9.7 (no changes necessary)
  * Use secure URIs for vcs-* in debian/control

 -- Philip Rinn <rinni@inventati.org>  Sat, 27 Feb 2016 15:40:28 +0100

gimagereader (3.1.2+git368fa8f-1) unstable; urgency=medium

  * Pick upstream snapshot (closes: #802391)
  * update debian/copyright

 -- Philip Rinn <rinni@inventati.org>  Sat, 31 Oct 2015 20:15:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,21 @@
 Source: gimagereader
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Philip Rinn <rinni@inventati.org>
+Maintainer: Philip Rinn <rinni@inventati.org>
 Build-Depends: debhelper (>= 9), cmake, intltool (>= 0.35.0),
  libgtkspellmm-3.0-dev, libgtkmm-3.0-dev,  libgtksourceviewmm-3.0-dev,
  libcairomm-1.0-dev, libpoppler-glib-dev, libtesseract-dev, libsane-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Homepage: https://github.com/manisandro/gImageReader
-Vcs-Git: git://anonscm.debian.org/collab-maint/gimagereader.git
-Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/gimagereader.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/gimagereader.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/gimagereader.git
 
 Package: gimagereader
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Graphical GTK+ front-end to tesseract-ocr
  gImageReader is a simple GTK+ front-end to tesseract-ocr. Tesseract is probably
- the most accurate open source optial character recognition (OCR) sotfware and
+ the most accurate open source optical character recognition (OCR) software and
  can recognize text in over 60 languages.
  .
  gImageReader supports automatic page layout detection but the user can also

## gimagereader 3.1.91

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,14 +3,16 @@
 INCLUDE(GSettings)
 SET(ENV{LC_ALL} "C")
 
+
 # Project properties
 PROJECT(gimagereader)
 SET(PACKAGE_NAME gImageReader)
-SET(PACKAGE_VERSION 3.1.2)
+SET(PACKAGE_VERSION 3.1.91)
 SET(PACKAGE_LOCALE_DIR "${CMAKE_INSTALL_PREFIX}/share/locale")
 
+
 # Variables
-SET(INTERFACE_TYPE "qt4" CACHE STRING "Select interface type: qt4/qt5/gtk")
+SET(INTERFACE_TYPE "qt5" CACHE STRING "Select interface type: qt4/qt5/gtk")
 MESSAGE(STATUS "${INTERFACE_TYPE} interface will be built")
 SET(MANUAL_DIR "share/doc/gimagereader" CACHE PATH "Path where manual will be installed")
 SET(ENABLE_VERSIONCHECK 1 CACHE BOOL "Enable version check")
@@ -46,6 +48,7 @@
 ADD_DEFINITIONS(-DENABLE_VERSIONCHECK=${ENABLE_VERSIONCHECK})
 ADD_DEFINITIONS(-DMANUAL_DIR=\"${MANUAL_DIR}\")
 ADD_DEFINITIONS(-std=c++11)
+
 
 # Dependencies
 FIND_PACKAGE(Gettext REQUIRED)
@@ -65,36 +68,50 @@
 IF("${INTERFACE_TYPE}" STREQUAL "gtk")
     PKG_CHECK_MODULES(GTKMM REQUIRED gtkmm-3.0)
     PKG_CHECK_MODULES(GTKSOURCEVIEWMM REQUIRED gtksourceviewmm-3.0)
-    PKG_CHECK_MODULES(GTKSPELLMM REQUIRED gtkspellmm-3.0)
+    PKG_CHECK_MODULES(GTKSPELLMM REQUIRED gtkspellmm-3.0>=3.0.4)
     PKG_CHECK_MODULES(CAIROMM REQUIRED cairomm-1.0)
+    PKG_CHECK_MODULES(PANGOMM REQUIRED pangomm-1.4)
     PKG_CHECK_MODULES(POPPLER REQUIRED poppler-glib)
+    PKG_CHECK_MODULES(JSONGLIB REQUIRED json-glib-1.0)
+    PKG_CHECK_MODULES(LIBXMLPP REQUIRED libxml++-2.6)
     INCLUDE_DIRECTORIES(
         ${GTKMM_INCLUDE_DIRS}
         ${GTKSOURCEVIEWMM_INCLUDE_DIRS}
         ${GTKSPELLMM_INCLUDE_DIRS}
         ${CAIROMM_INCLUDE_DIRS}
+        ${PANGOMM_INCLUDE_DIRS}
         ${POPPLER_INCLUDE_DIRS}
+        ${JSONGLIB_INCLUDE_DIRS}
+        ${LIBXMLPP_INCLUDE_DIRS}
     )
     SET(gimagereader_LIBS
         ${GTKMM_LDFLAGS}
         ${GTKSOURCEVIEWMM_LDFLAGS}
         ${GTKSPELLMM_LDFLAGS}
         ${CAIROMM_LDFLAGS}
+        ${PANGOMM_LDFLAGS}
         ${POPPLER_LDFLAGS}
+        ${JSONGLIB_LDFLAGS}
+        ${LIBXMLPP_LDFLAGS}
     )
     SET(srcdir "gtk")
 ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt4")
     SET(CMAKE_AUTOMOC ON)
     FIND_PACKAGE(Qt4 REQUIRED)
-    PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt4)
+    PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt4>=0.8.0)
     PKG_CHECK_MODULES(POPPLER REQUIRED poppler-qt4)
-    INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS})
-    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS})
+    PKG_CHECK_MODULES(QJSON REQUIRED QJson)
+    INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS} ${QJSON_INCLUDE_DIRS})
+    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS} ${QJSON_LDFLAGS})
     SET(srcdir "qt")
 ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
     SET(CMAKE_AUTOMOC ON)
+    FIND_PACKAGE(Qt5DBus REQUIRED)
+    FIND_PACKAGE(Qt5Network REQUIRED)
     FIND_PACKAGE(Qt5Widgets REQUIRED)
-    PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt5)
+    FIND_PACKAGE(Qt5Xml REQUIRED)
+    FIND_PACKAGE(Qt5PrintSupport REQUIRED)
+    PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt5>=0.8.0)
     PKG_CHECK_MODULES(POPPLER REQUIRED poppler-qt5)
     INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS})
     SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS})
@@ -108,12 +125,19 @@
 
 # Files
 FILE(GLOB gimagereader_SRCS ${srcdir}/src/*.cc)
+# sort lists to avoid dependency on readdir() order and make build reproducible
+LIST(SORT gimagereader_SRCS)
 FILE(GLOB gimagereader_HDRS ${srcdir}/src/*.hh)
+LIST(SORT gimagereader_HDRS)
 FILE(GLOB gimagereader_FORMS ${srcdir}/data/*.ui)
+LIST(SORT gimagereader_FORMS)
 FILE(GLOB gimagereader_ICONS data/icons/*.png)
+LIST(SORT gimagereader_ICONS)
 FILE(GLOB gimagereader_PO po/*.po)
+LIST(SORT gimagereader_PO)
 IF("${srcdir}" STREQUAL "qt")
     FILE(GLOB gimagereader_RESOURCES qt/data/*.qrc)
+    LIST(SORT gimagereader_RESOURCES)
 ENDIF()
 IF(UNIX)
     LIST(APPEND gimagereader_SRCS ${srcdir}/src/scanner/ScannerSane.cc)
@@ -133,7 +157,9 @@
         DEPENDS ${CMAKE_SOURCE_DIR}/gtk/data/gimagereader.gresource.xml
                 ${CMAKE_SOURCE_DIR}/gtk/data/gimagereader.ui
                 ${CMAKE_SOURCE_DIR}/gtk/data/crashhandler.ui
-                ${CMAKE_SOURCE_DIR}/gtk/data/appmenu.ui)
+                ${CMAKE_SOURCE_DIR}/gtk/data/appmenu.ui
+                ${CMAKE_SOURCE_DIR}/gtk/data/editor_text.ui
+                ${CMAKE_SOURCE_DIR}/gtk/data/editor_hocr.ui)
     LIST(APPEND gimagereader_SRCS gimagereader.gresource.c)
 ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt4")
     QT4_WRAP_UI(gimagereader_FORMS_HEADERS ${gimagereader_FORMS})
@@ -190,10 +216,10 @@
 SET_TARGET_PROPERTIES(gimagereader PROPERTIES COMPILE_FLAGS "-fopenmp")
 SET_TARGET_PROPERTIES(gimagereader PROPERTIES OUTPUT_NAME gimagereader-${INTERFACE_TYPE})
 IF("${INTERFACE_TYPE}" STREQUAL "qt4")
-    QT4_USE_MODULES(gimagereader Core Gui Network DBus)
+    QT4_USE_MODULES(gimagereader Core Gui Network DBus Xml)
     ADD_DEPENDENCIES(gimagereader gettextizeui)
 ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
-    QT5_USE_MODULES(gimagereader Widgets Network DBus)
+    QT5_USE_MODULES(gimagereader Widgets Network DBus Xml PrintSupport)
     ADD_DEPENDENCIES(gimagereader gettextizeui)
 ENDIF()

=== debian/changelog ===
gimagereader (3.1.91-2) unstable; urgency=medium

  * add debian/patches/02-fix-ftbfs.patch:
    - Fix FTBFS due to missing implicit bool conversion
  * Fix typo in doc-base file

 -- Philip Rinn <rinni@inventati.org>  Wed, 28 Sep 2016 19:59:40 +0200

gimagereader (3.1.91-1) unstable; urgency=medium

  * new upstream version (closes: LP: #1579707):
    - remove all patches as they are merged upstream
  * add debian/patches/01-catch-segfaults-tesseract.patch:
    - catch deliberate segfaults created by tesseract
  * update debian/copyright
  * Bump Standards-Version to 3.9.8 (no changes necessary)

 -- Philip Rinn <rinni@inventati.org>  Mon, 13 Jun 2016 19:49:08 +0200

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,30 @@
 Section: graphics
 Priority: optional
 Maintainer: Philip Rinn <rinni@inventati.org>
-Build-Depends: debhelper (>= 9), cmake, intltool (>= 0.35.0),
- libgtkspellmm-3.0-dev, libgtkmm-3.0-dev,  libgtksourceviewmm-3.0-dev,
- libcairomm-1.0-dev, libpoppler-glib-dev, libtesseract-dev, libsane-dev
-Standards-Version: 3.9.7
+Build-Depends:
+ cmake,
+ debhelper (>= 9),
+ intltool (>= 0.35.0),
+ libcairomm-1.0-dev,
+ libgtkmm-3.0-dev,
+ libgtksourceviewmm-3.0-dev,
+ libgtkspellmm-3.0-dev (>= 3.0.4),
+ libjson-glib-dev,
+ libpangomm-1.4-dev,
+ libpoppler-glib-dev,
+ libsane-dev,
+ libtesseract-dev,
+ libxml++2.6-dev,
+Standards-Version: 3.9.8
 Homepage: https://github.com/manisandro/gImageReader
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/gimagereader.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/gimagereader.git
 
 Package: gimagereader
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Graphical GTK+ front-end to tesseract-ocr
  gImageReader is a simple GTK+ front-end to tesseract-ocr. Tesseract is probably
  the most accurate open source optical character recognition (OCR) software and

## gimagereader 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # Project properties
 PROJECT(gimagereader)
 SET(PACKAGE_NAME gImageReader)
-SET(PACKAGE_VERSION 3.1.91)
+SET(PACKAGE_VERSION 3.2.0)
 SET(PACKAGE_LOCALE_DIR "${CMAKE_INSTALL_PREFIX}/share/locale")
 
 
@@ -55,25 +55,38 @@
 FIND_PACKAGE(PkgConfig REQUIRED)
 PKG_CHECK_MODULES(TESSERACT tesseract)
 IF(NOT TESSERACT_FOUND)
-    MESSAGE(WANING "Using hardcoded tesseract cflags and libs")
+    MESSAGE(WARNING "Using hardcoded cflags and ldflags for tesseract")
     SET(TESSERACT_INCLUDE_DIRS /usr/include/tesseract)
     SET(TESSERACT_LDFLAGS -ltesseract)
 ENDIF(NOT TESSERACT_FOUND)
 IF(UNIX)
     PKG_CHECK_MODULES(SANE sane-backends)
 ENDIF(UNIX)
+SET(PODOFO_LDFLAGS -lpodofo)
 
 INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR} ${TESSERACT_INCLUDE_DIRS} ${SANE_INCLUDE_DIRS})
 
 IF("${INTERFACE_TYPE}" STREQUAL "gtk")
     PKG_CHECK_MODULES(GTKMM REQUIRED gtkmm-3.0)
     PKG_CHECK_MODULES(GTKSOURCEVIEWMM REQUIRED gtksourceviewmm-3.0)
-    PKG_CHECK_MODULES(GTKSPELLMM REQUIRED gtkspellmm-3.0>=3.0.4)
+    PKG_CHECK_MODULES(GTKSPELLMM REQUIRED gtkspellmm-3.0>=3.0.5)
     PKG_CHECK_MODULES(CAIROMM REQUIRED cairomm-1.0)
     PKG_CHECK_MODULES(PANGOMM REQUIRED pangomm-1.4)
     PKG_CHECK_MODULES(POPPLER REQUIRED poppler-glib)
     PKG_CHECK_MODULES(JSONGLIB REQUIRED json-glib-1.0)
     PKG_CHECK_MODULES(LIBXMLPP REQUIRED libxml++-2.6)
+    FIND_PACKAGE(JPEG)
+    IF(JPEG_FOUND)
+        SET(LIBJPEG_INCLUDE_DIRS ${JPEG_INCLUDE_DIRS})
+        SET(LIBJPEG_LDFLAGS ${JPEG_LIBRARIES})
+    ELSE()
+        PKG_CHECK_MODULES(LIBJPEG libjpeg)
+        IF(NOT LIBJPEG_FOUND)
+            MESSAGE(WARNING "Using hardcoded cflags and ldflags for libjpeg")
+            SET(LIBJPEG_LDFLAGS "-ljpeg")
+        ENDIF()
+    ENDIF()
+    PKG_CHECK_MODULES(FONTCONFIG REQUIRED fontconfig)
     INCLUDE_DIRECTORIES(
         ${GTKMM_INCLUDE_DIRS}
         ${GTKSOURCEVIEWMM_INCLUDE_DIRS}
@@ -83,6 +96,8 @@
         ${POPPLER_INCLUDE_DIRS}
         ${JSONGLIB_INCLUDE_DIRS}
         ${LIBXMLPP_INCLUDE_DIRS}
+        ${LIBJPEG_INCLUDE_DIRS}
+        ${FONTCONFIG_INCLUDE_DIRS}
     )
     SET(gimagereader_LIBS
         ${GTKMM_LDFLAGS}
@@ -93,6 +108,9 @@
         ${POPPLER_LDFLAGS}
         ${JSONGLIB_LDFLAGS}
         ${LIBXMLPP_LDFLAGS}
+        ${LIBJPEG_LDFLAGS}
+        ${PODOFO_LDFLAGS}
+        ${FONTCONFIG_LDFLAGS}
     )
     SET(srcdir "gtk")
 ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt4")
@@ -102,7 +120,7 @@
     PKG_CHECK_MODULES(POPPLER REQUIRED poppler-qt4)
     PKG_CHECK_MODULES(QJSON REQUIRED QJson)
     INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS} ${QJSON_INCLUDE_DIRS})
-    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS} ${QJSON_LDFLAGS})
+    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS} ${QJSON_LDFLAGS} ${PODOFO_LDFLAGS})
     SET(srcdir "qt")
 ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
     SET(CMAKE_AUTOMOC ON)
@@ -114,14 +132,13 @@
     PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt5>=0.8.0)
     PKG_CHECK_MODULES(POPPLER REQUIRED poppler-qt5)
     INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS})
-    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS})
+    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS} ${PODOFO_LDFLAGS})
     SET(srcdir "qt")
 ELSE()
     MESSAGE(FATAL_ERROR "Invalid interface type ${INTERFACE_TYPE}")
 ENDIF()
 
 INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/${srcdir}/src/ )
-
 
 # Files
 FILE(GLOB gimagereader_SRCS ${srcdir}/src/*.cc)
@@ -133,8 +150,6 @@
 LIST(SORT gimagereader_FORMS)
 FILE(GLOB gimagereader_ICONS data/icons/*.png)
 LIST(SORT gimagereader_ICONS)
-FILE(GLOB gimagereader_PO po/*.po)
-LIST(SORT gimagereader_PO)
 IF("${srcdir}" STREQUAL "qt")
     FILE(GLOB gimagereader_RESOURCES qt/data/*.qrc)
     LIST(SORT gimagereader_RESOURCES)
@@ -180,7 +195,9 @@
 
 FILE(READ po/LINGUAS langs_string)
 STRING(REGEX MATCHALL "[a-zA-Z_]+" langs "${langs_string}")
-FILE(COPY ${gimagereader_PO} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
+FOREACH(lang ${langs})
+    CONFIGURE_FILE(po/${lang}.po ${lang}.po COPYONLY)
+ENDFOREACH()
 GETTEXT_PROCESS_POT_FILE(po/gimagereader.pot ALL INSTALL_DESTINATION ${PACKAGE_LOCALE_DIR} LANGUAGES ${langs})
 
 IF(MINGW)

=== debian/changelog ===
gimagereader (3.2.0-1) unstable; urgency=medium

  * new upstream version:
    - remove all patches as they are merged upstream
    - Add builddependencies libjpeg-dev and libpodofo-dev
  * Bump debhelper compat from 9 to 10 (no changes necessary).

 -- Philip Rinn <rinni@inventati.org>  Thu, 24 Nov 2016 22:17:44 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,16 @@
 Maintainer: Philip Rinn <rinni@inventati.org>
 Build-Depends:
  cmake,
- debhelper (>= 9),
+ debhelper (>= 10),
  intltool (>= 0.35.0),
  libcairomm-1.0-dev,
  libgtkmm-3.0-dev,
  libgtksourceviewmm-3.0-dev,
  libgtkspellmm-3.0-dev (>= 3.0.4),
+ libjpeg-dev,
  libjson-glib-dev,
  libpangomm-1.4-dev,
+ libpodofo-dev,
  libpoppler-glib-dev,
  libsane-dev,
  libtesseract-dev,

## gimagereader 3.2.1

=== debian/changelog ===
gimagereader (3.2.1-1build1) artful; urgency=medium

  * No-change rebuild against libpodofo0.9.5.

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Thu, 22 Jun 2017 18:38:21 +0200

gimagereader (3.2.1-1) unstable; urgency=medium

  * new upstream version (closes: #856206)

 -- Philip Rinn <rinni@inventati.org>  Wed, 14 Jun 2017 15:39:57 +0200

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ --with autoreconf --parallel
+	dh $@ --parallel
 
 override_dh_auto_configure:
-	dh_auto_configure -- --disable-versioncheck
+	dh_auto_configure -- -DINTERFACE_TYPE=gtk -DENABLE_VERSIONCHECK=0

## gimagereader 3.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 # Project properties
 PROJECT(gimagereader)
 SET(PACKAGE_NAME gImageReader)
-SET(PACKAGE_VERSION 3.2.0)
+SET(PACKAGE_VERSION 3.2.3)
 SET(PACKAGE_LOCALE_DIR "${CMAKE_INSTALL_PREFIX}/share/locale")
 
 
@@ -47,7 +47,8 @@
 ADD_DEFINITIONS(-DGETTEXT_PACKAGE=\"${CMAKE_PROJECT_NAME}\")
 ADD_DEFINITIONS(-DENABLE_VERSIONCHECK=${ENABLE_VERSIONCHECK})
 ADD_DEFINITIONS(-DMANUAL_DIR=\"${MANUAL_DIR}\")
-ADD_DEFINITIONS(-std=c++11)
+SET(CMAKE_CXX_STANDARD 11)
+SET(CXX_STANDARD_REQUIRED ON)
 
 
 # Dependencies
@@ -64,7 +65,7 @@
 ENDIF(UNIX)
 SET(PODOFO_LDFLAGS -lpodofo)
 
-INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR} ${TESSERACT_INCLUDE_DIRS} ${SANE_INCLUDE_DIRS})
+INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/common ${CMAKE_BINARY_DIR} ${TESSERACT_INCLUDE_DIRS} ${SANE_INCLUDE_DIRS})
 
 IF("${INTERFACE_TYPE}" STREQUAL "gtk")
     PKG_CHECK_MODULES(GTKMM REQUIRED gtkmm-3.0)
@@ -141,10 +142,10 @@
 INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/${srcdir}/src/ )
 
 # Files
-FILE(GLOB gimagereader_SRCS ${srcdir}/src/*.cc)
+FILE(GLOB gimagereader_SRCS ${srcdir}/src/*.cc common/*.cc)
 # sort lists to avoid dependency on readdir() order and make build reproducible
 LIST(SORT gimagereader_SRCS)
-FILE(GLOB gimagereader_HDRS ${srcdir}/src/*.hh)
+FILE(GLOB gimagereader_HDRS ${srcdir}/src/*.hh common/*.hh)
 LIST(SORT gimagereader_HDRS)
 FILE(GLOB gimagereader_FORMS ${srcdir}/data/*.ui)
 LIST(SORT gimagereader_FORMS)
@@ -230,13 +231,18 @@
     -ldl
     -lgomp
 )
-SET_TARGET_PROPERTIES(gimagereader PROPERTIES COMPILE_FLAGS "-fopenmp")
+
+IF("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+ELSE()
+  SET_TARGET_PROPERTIES(gimagereader PROPERTIES COMPILE_FLAGS "-fopenmp")
+ENDIF()
+
 SET_TARGET_PROPERTIES(gimagereader PROPERTIES OUTPUT_NAME gimagereader-${INTERFACE_TYPE})
 IF("${INTERFACE_TYPE}" STREQUAL "qt4")
-    QT4_USE_MODULES(gimagereader Core Gui Network DBus Xml)
+    TARGET_LINK_LIBRARIES(gimagereader Qt4::QtCore Qt4::QtGui Qt4::QtNetwork Qt4::QtDBus Qt4::QtXml)
     ADD_DEPENDENCIES(gimagereader gettextizeui)
 ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
-    QT5_USE_MODULES(gimagereader Widgets Network DBus Xml PrintSupport)
+    TARGET_LINK_LIBRARIES(gimagereader Qt5::Widgets Qt5::Network Qt5::DBus Qt5::Xml Qt5::PrintSupport)
     ADD_DEPENDENCIES(gimagereader gettextizeui)
 ENDIF()

=== debian/changelog ===
gimagereader (3.2.3-3build1) disco; urgency=medium

  * No-change rebuild against libpodofo0.9.6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 11 Nov 2018 09:09:09 +0000

gimagereader (3.2.3-3) unstable; urgency=medium

  * add debian/patches/04_set_local_c_for_tesseract.patch:
    - Adapt for tesseract 4.x aborting if LANG!=C (closes: #906243)

 -- Philip Rinn <rinni@inventati.org>  Thu, 16 Aug 2018 22:19:01 +0200

gimagereader (3.2.3-2) unstable; urgency=medium

  * add debian/patches/01_fix-appstream-metadata.patch:
    - Use current format and location for appstream metadata
  * add debian/patches/02_remove-pixdata-conversions.patch:
    - Remove pixdata conversions (closes: #886139)
  * add debian/patches/03_fix-slowdown-with-tesseract4.patch:
    - Fix massive slowdown with tesseract 4.00dev
  * Bump Standards-Version to 4.1.3 (no changes necessary)

 -- Philip Rinn <rinni@inventati.org>  Fri, 05 Jan 2018 16:08:46 +0100

gimagereader (3.2.3-1) unstable; urgency=medium

  * new upstream version
  * Bump Standards-Version to 4.0.0 (no changes necessary)

 -- Philip Rinn <rinni@inventati.org>  Mon, 17 Jul 2017 12:49:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: gimagereader
 Section: graphics
 Priority: optional
-Maintainer: Philip Rinn <rinni@inventati.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Philip Rinn <rinni@inventati.org>
 Build-Depends:
  cmake,
  debhelper (>= 10),
@@ -18,10 +19,10 @@
  libsane-dev,
  libtesseract-dev,
  libxml++2.6-dev,
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: https://github.com/manisandro/gImageReader
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/gimagereader.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/gimagereader.git
+Vcs-Git: https://salsa.debian.org/debian/gimagereader.git
+Vcs-Browser: https://salsa.debian.org/debian/gimagereader
 
 Package: gimagereader
 Architecture: any

## gimagereader 3.3.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
LIST(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
INCLUDE(GSettings)
SET(ENV{LC_ALL} "C")


# Project properties
PROJECT(gimagereader)
SET(PACKAGE_NAME gImageReader)
SET(PACKAGE_VERSION 3.3.0)
SET(PACKAGE_LOCALE_DIR "${CMAKE_INSTALL_PREFIX}/share/locale")


# Variables
SET(INTERFACE_TYPE "qt5" CACHE STRING "Select interface type: qt4/qt5/gtk")
MESSAGE(STATUS "${INTERFACE_TYPE} interface will be built")
SET(MANUAL_DIR "share/doc/gimagereader" CACHE PATH "Path where manual will be installed")
SET(ENABLE_VERSIONCHECK 1 CACHE BOOL "Enable version check")
EXECUTE_PROCESS(COMMAND date +%a\ %b\ %d\ %Y OUTPUT_VARIABLE PACKAGE_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
EXECUTE_PROCESS(COMMAND date -R OUTPUT_VARIABLE PACKAGE_RFC_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
EXECUTE_PROCESS(COMMAND git rev-parse HEAD OUTPUT_VARIABLE PACKAGE_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE)

IF(NOT IS_ABSOLUTE "${MANUAL_DIR}")
    SET(MANUAL_DIR "${CMAKE_INSTALL_PREFIX}/${MANUAL_DIR}")
ENDIF()

# Configure files
CONFIGURE_FILE(data/gimagereader.appdata.xml.in data/gimagereader-${INTERFACE_TYPE}.appdata.xml @ONLY)
CONFIGURE_FILE(packaging/gimagereader.spec.in packaging/gimagereader.spec @ONLY)
CONFIGURE_FILE(packaging/debian/changelog.in packaging/debian/changelog @ONLY)

FILE(GLOB gimagereader_HTML RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} data/manual*.html.in)
SET(manualFiles)
FOREACH(inFile ${gimagereader_HTML})
    STRING(REGEX REPLACE ".in\$" "" outFile "${inFile}")
    CONFIGURE_FILE(${inFile} ${outFile} @ONLY)
    SET(manualFiles ${manualFiles} "${CMAKE_CURRENT_BINARY_DIR}/${outFile}")
ENDFOREACH()


# Definitions
ADD_DEFINITIONS(-DPACKAGE_NAME=\"${PACKAGE_NAME}\")
ADD_DEFINITIONS(-DPACKAGE_VERSION=\"${PACKAGE_VERSION}\")
ADD_DEFINITIONS(-DPACKAGE_REVISION=\"${PACKAGE_REVISION}\")
ADD_DEFINITIONS(-DGETTEXT_PACKAGE=\"${CMAKE_PROJECT_NAME}\")
ADD_DEFINITIONS(-DENABLE_VERSIONCHECK=${ENABLE_VERSIONCHECK})
ADD_DEFINITIONS(-DMANUAL_DIR=\"${MANUAL_DIR}\")
SET(CMAKE_CXX_STANDARD 11)
SET(CXX_STANDARD_REQUIRED ON)


# Dependencies
FIND_PACKAGE(Gettext REQUIRED)
FIND_PACKAGE(PkgConfig REQUIRED)
PKG_CHECK_MODULES(TESSERACT tesseract)
PKG_CHECK_MODULES(ddjvuapi REQUIRED ddjvuapi)
IF(NOT TESSERACT_FOUND)
    MESSAGE(WARNING "Using hardcoded cflags and ldflags for tesseract")
    SET(TESSERACT_INCLUDE_DIRS /usr/include/tesseract)
    SET(TESSERACT_LDFLAGS -ltesseract)
ENDIF(NOT TESSERACT_FOUND)
IF(UNIX)
    PKG_CHECK_MODULES(SANE sane-backends)
ENDIF(UNIX)
FIND_PROGRAM(INTLTOOL_MERGE_EXECUTABLE intltool-merge)
IF(NOT INTLTOOL_MERGE_EXECUTABLE)
    MESSAGE(FATAL_ERROR "Couldn't find intltool-merge, please install intltool")
ENDIF(NOT INTLTOOL_MERGE_EXECUTABLE)
SET(PODOFO_LDFLAGS -lpodofo)

PKG_CHECK_MODULES(ENCHANT enchant-2)
IF(ENCHANT_FOUND)
    ADD_DEFINITIONS(-DHAVE_ENCHANT2)
ELSE(ENCHANT_FOUND)
    PKG_CHECK_MODULES(ENCHANT REQUIRED enchant)
    IF(ENCHANT_VERSION VERSION_GREATER_EQUAL 2)
        ADD_DEFINITIONS(-DHAVE_ENCHANT2)
    ENDIF()
ENDIF(ENCHANT_FOUND)

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/common ${CMAKE_BINARY_DIR} ${TESSERACT_INCLUDE_DIRS} ${SANE_INCLUDE_DIRS})

IF("${INTERFACE_TYPE}" STREQUAL "gtk")
    PKG_CHECK_MODULES(GTKMM REQUIRED gtkmm-3.0)
    PKG_CHECK_MODULES(GTKSOURCEVIEWMM REQUIRED gtksourceviewmm-3.0)
    PKG_CHECK_MODULES(GTKSPELLMM REQUIRED gtkspellmm-3.0>=3.0.5)
    PKG_CHECK_MODULES(CAIROMM REQUIRED cairomm-1.0)
    PKG_CHECK_MODULES(PANGOMM REQUIRED pangomm-1.4)
    PKG_CHECK_MODULES(POPPLER REQUIRED poppler-glib)
    PKG_CHECK_MODULES(JSONGLIB REQUIRED json-glib-1.0)
    PKG_CHECK_MODULES(LIBXMLPP libxml++-3.0)
    IF(LIBXMLPP_FOUND)
      ADD_DEFINITIONS(-DHAVE_LIBXMLPP_3)
    ELSE()
      PKG_CHECK_MODULES(LIBXMLPP REQUIRED libxml++-2.6)
      ADD_DEFINITIONS(-DHAVE_LIBXMLPP_2)
    ENDIF()
    PKG_CHECK_MODULES(LIBZIP REQUIRED libzip)
    FIND_PACKAGE(JPEG)
    IF(JPEG_FOUND)
        SET(LIBJPEG_INCLUDE_DIRS ${JPEG_INCLUDE_DIRS})
        SET(LIBJPEG_LDFLAGS ${JPEG_LIBRARIES})
    ELSE()
        PKG_CHECK_MODULES(LIBJPEG libjpeg)
        IF(NOT LIBJPEG_FOUND)
            MESSAGE(WARNING "Using hardcoded cflags and ldflags for libjpeg")
            SET(LIBJPEG_LDFLAGS "-ljpeg")
        ENDIF()
    ENDIF()
    PKG_CHECK_MODULES(FONTCONFIG REQUIRED fontconfig)
    PKG_CHECK_MODULES(UUID REQUIRED uuid)
    INCLUDE_DIRECTORIES(
        ${GTKMM_INCLUDE_DIRS}
        ${GTKSOURCEVIEWMM_INCLUDE_DIRS}
        ${GTKSPELLMM_INCLUDE_DIRS}
        ${CAIROMM_INCLUDE_DIRS}
        ${PANGOMM_INCLUDE_DIRS}
        ${POPPLER_INCLUDE_DIRS}
        ${JSONGLIB_INCLUDE_DIRS}
        ${LIBXMLPP_INCLUDE_DIRS}
        ${LIBJPEG_INCLUDE_DIRS}
        ${FONTCONFIG_INCLUDE_DIRS}
        ${LIBZIP_INCLUDE_DIRS}
        ${UUID_INCLUDE_DIRS}
    )
    SET(gimagereader_LIBS
        ${GTKMM_LDFLAGS}
        ${GTKSOURCEVIEWMM_LDFLAGS}
        ${GTKSPELLMM_LDFLAGS}
        ${CAIROMM_LDFLAGS}
        ${PANGOMM_LDFLAGS}
        ${POPPLER_LDFLAGS}
        ${JSONGLIB_LDFLAGS}
        ${LIBXMLPP_LDFLAGS}
        ${LIBJPEG_LDFLAGS}
        ${PODOFO_LDFLAGS}
        ${FONTCONFIG_LDFLAGS}
        ${LIBZIP_LDFLAGS}
        ${UUID_LDFLAGS}
    )
    SET(srcdir "gtk")
ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt4")
    SET(CMAKE_AUTOMOC ON)
    FIND_PACKAGE(Qt4 REQUIRED)
    FIND_PACKAGE(QuaZip)
    IF(NOT QUAZIP_FOUND)
        FIND_PATH(QUAZIP_INCLUDE_DIR NAME quazipfile.h PATH_SUFFIXES quazip)
        FIND_LIBRARY(QUAZIP_LIBRARIES quazip)
        IF(NOT QUAZIP_INCLUDE_DIR OR NOT QUAZIP_LIBRARIES)
            MESSAGE(FATAL_ERROR "QuaZip is required but was not found")
        ENDIF()
    ENDIF()
    PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt4>=0.8.0)
    PKG_CHECK_MODULES(POPPLER REQUIRED poppler-qt4)
    PKG_CHECK_MODULES(QJSON REQUIRED QJson)
    INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS} ${QJSON_INCLUDE_DIRS} ${QUAZIP_INCLUDE_DIR})
    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS} ${QJSON_LDFLAGS} ${PODOFO_LDFLAGS} ${QUAZIP_LIBRARIES})
    SET(srcdir "qt")
ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
    SET(CMAKE_AUTOMOC ON)
    FIND_PACKAGE(Qt5DBus REQUIRED)
    FIND_PACKAGE(Qt5Network REQUIRED)
    FIND_PACKAGE(Qt5Widgets REQUIRED)
    FIND_PACKAGE(Qt5Xml REQUIRED)
    FIND_PACKAGE(Qt5PrintSupport REQUIRED)
    FIND_PACKAGE(QuaZip5)
    IF(NOT QUAZIP_FOUND)
        FIND_PATH(QUAZIP_INCLUDE_DIR NAME quazipfile.h PATH_SUFFIXES quazip5)
        FIND_LIBRARY(QUAZIP_LIBRARIES quazip5)
        IF(NOT QUAZIP_INCLUDE_DIR OR NOT QUAZIP_LIBRARIES)
            MESSAGE(FATAL_ERROR "QuaZip5 is required but was not found")
        ENDIF()
    ENDIF()
    PKG_CHECK_MODULES(QTSPELL REQUIRED QtSpell-qt5>=0.8.0)
    PKG_CHECK_MODULES(POPPLER REQUIRED poppler-qt5)
    INCLUDE_DIRECTORIES(${QTSPELL_INCLUDE_DIRS} ${POPPLER_INCLUDE_DIRS} ${QUAZIP_INCLUDE_DIR})
    SET(gimagereader_LIBS ${QTSPELL_LDFLAGS} ${POPPLER_LDFLAGS} ${PODOFO_LDFLAGS} ${QUAZIP_LIBRARIES})
    SET(srcdir "qt")
ELSE()
    MESSAGE(FATAL_ERROR "Invalid interface type ${INTERFACE_TYPE}")
ENDIF()

INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}/${srcdir}/src/
  ${CMAKE_SOURCE_DIR}/${srcdir}/src/hocr/
)

# Files
# sort lists to avoid dependency on readdir() order and make build reproducible
FILE(GLOB gimagereader_SRCS
  ${srcdir}/src/*.cc
  ${srcdir}/src/hocr/*.cc
  common/*.cc
)
LIST(SORT gimagereader_SRCS)

FILE(GLOB gimagereader_HDRS
  ${srcdir}/src/*.hh
  ${srcdir}/src/hocr/*.hh
  common/*.hh)
LIST(SORT gimagereader_HDRS)

FILE(GLOB gimagereader_FORMS ${srcdir}/data/*.ui)
LIST(SORT gimagereader_FORMS)

FILE(GLOB gimagereader_ICONS data/icons/*.png)
LIST(SORT gimagereader_ICONS)

IF("${srcdir}" STREQUAL "qt")
    FILE(GLOB gimagereader_RESOURCES qt/data/*.qrc)
    LIST(SORT gimagereader_RESOURCES)
ENDIF()
IF(UNIX)
    LIST(APPEND gimagereader_SRCS ${srcdir}/src/scanner/ScannerSane.cc)
    LIST(APPEND gimagereader_HDRS ${srcdir}/src/scanner/ScannerSane.hh)
ELSE(UNIX)
    LIST(APPEND gimagereader_SRCS ${srcdir}/src/scanner/ScannerTwain.cc)
    LIST(APPEND gimagereader_HDRS ${srcdir}/src/scanner/ScannerTwain.hh)
ENDIF(UNIX)


# Generate resources
IF("${srcdir}" STREQUAL "gtk")
    ADD_SCHEMA("gtk/data/org.gnome.gimagereader.gschema.xml")
    ADD_CUSTOM_COMMAND(
        OUTPUT  ${CMAKE_BINARY_DIR}/gimagereader.gresource.c
        COMMAND glib-compile-resources gimagereader.gresource.xml ARGS --target=${CMAKE_BINARY_DIR}/gimagereader.gresource.c --generate-source
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/gtk/data/
        DEPENDS ${gimagereader_FORMS})
    LIST(APPEND gimagereader_SRCS ${CMAKE_BINARY_DIR}/gimagereader.gresource.c)

    # Just to allow running the application from the build tree (via XDG_DATA_DIRS=$PWD:$XDG_DATA_DIRS ./gimagereader-gtk)
    ADD_CUSTOM_COMMAND(
        OUTPUT  ${CMAKE_BINARY_DIR}/glib-2.0/schemas/gschemas.compiled
        COMMAND ${CMAKE_COMMAND} ARGS -E copy ${CMAKE_SOURCE_DIR}/gtk/data/org.gnome.gimagereader.gschema.xml ${CMAKE_BINARY_DIR}/glib-2.0/schemas/org.gnome.gimagereader.gschema.xml
        COMMAND glib-compile-schemas ARGS ${CMAKE_BINARY_DIR}/glib-2.0/schemas/
        DEPENDS ${CMAKE_SOURCE_DIR}/gtk/data/org.gnome.gimagereader.gschema.xml
    )
    SET(gimagereader_RESOURCES_RCC ${CMAKE_BINARY_DIR}/glib-2.0/schemas/gschemas.compiled)

    FOREACH(form ${gimagereader_FORMS})
        GET_FILENAME_COMPONENT(outfile ${form} NAME_WE)
        SET(outfile ${CMAKE_BINARY_DIR}/ui_${outfile}.hh)
        ADD_CUSTOM_COMMAND(
            OUTPUT ${outfile}
            COMMAND python3 ARGS ${CMAKE_SOURCE_DIR}/gtk/data/uigen.py ${form}
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
            DEPENDS ${form}
        )
        LIST(APPEND gimagereader_FORMS_HEADERS ${outfile})
    ENDFOREACH()

ELSEIF("${srcdir}" STREQUAL "qt")
    IF("${INTERFACE_TYPE}" STREQUAL "qt4")
        QT4_ADD_RESOURCES(gimagereader_RESOURCES_RCC ${gimagereader_RESOURCES})
        SET(UIC_EXECUTABLE ${QT_UIC_EXECUTABLE})
    ELSEIF("${INTERFACE_TYPE}" STREQUAL "qt5")
        QT5_ADD_RESOURCES(gimagereader_RESOURCES_RCC ${gimagereader_RESOURCES})
        SET(UIC_EXECUTABLE Qt5::uic)
    ENDIF()

    # Custom WRAP_UI which also gettext-izes the result
    MESSAGE(${CMAKE_COMMAND})
    FOREACH(form ${gimagereader_FORMS})
        GET_FILENAME_COMPONENT(outfile ${form} NAME_WE)
        SET(outfile ${CMAKE_BINARY_DIR}/ui_${outfile}.h)
        ADD_CUSTOM_COMMAND(
            OUTPUT ${outfile}
            COMMAND ${UIC_EXECUTABLE} ARGS -o ${outfile} ${form}
            COMMAND ${CMAKE_COMMAND} ARGS -P ${CMAKE_SOURCE_DIR}/cmake/gettextizeui.cmake ${outfile}
            DEPENDS ${form}
        )
        LIST(APPEND gimagereader_FORMS_HEADERS ${outfile})
    ENDFOREACH()

    SET_PROPERTY(SOURCE ${gimagereader_FORMS_HEADERS} PROPERTY SKIP_AUTOMOC ON)
    SET_PROPERTY(SOURCE ${gimagereader_RESOURCES_RCC} PROPERTY SKIP_AUTOMOC ON)
ENDIF()


# Process translations
FILE(READ po/LINGUAS langs_string)
STRING(REGEX MATCHALL "[a-zA-Z_]+" langs "${langs_string}")
FOREACH(lang ${langs})
    CONFIGURE_FILE(po/${lang}.po ${lang}.po COPYONLY)
ENDFOREACH()
GETTEXT_PROCESS_POT_FILE(po/gimagereader.pot ALL INSTALL_DESTINATION ${PACKAGE_LOCALE_DIR} LANGUAGES ${langs})

# Process desktop file
CONFIGURE_FILE(data/gimagereader.desktop.in data/gimagereader-${INTERFACE_TYPE}.desktop.in @ONLY)
# add translations to desktop file
ADD_CUSTOM_COMMAND(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/data/gimagereader-${INTERFACE_TYPE}.desktop
    COMMAND ${INTLTOOL_MERGE_EXECUTABLE} --desktop-style ${CMAKE_SOURCE_DIR}/po ${CMAKE_CURRENT_BINARY_DIR}/data/gimagereader-${INTERFACE_TYPE}.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/data/gimagereader-${INTERFACE_TYPE}.desktop
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/data/gimagereader-${INTERFACE_TYPE}.desktop.in)
ADD_CUSTOM_TARGET(desktop_file ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/data/gimagereader-${INTERFACE_TYPE}.desktop)

IF(MINGW)
  ENABLE_LANGUAGE(RC)
  SET(CMAKE_RC_COMPILER_INIT ${CMAKE_GENERATOR_RC})

=== debian/changelog ===
gimagereader (3.3.0-1) unstable; urgency=medium

  [ Philip Rinn ]
  * New upstream version (closes: #889633):
    - Add build dependencies libdjvulibre-dev, libzip-dev, python3-gi, uuid-dev
  * Drop patches that are applied upstream:
    - debian/patches/01_fix-appstream-metadata.patch
    - debian/patches/02_remove-pixdata-conversions.patch
    - debian/patches/04_set_local_c_for_tesseract.patch
  * Bump Standards-Version to 4.2.1 (no changes necessary)
  * Bump debhelper compat version to 11 (no changes necessary)
  * Add upstream metadata
  * Update debian/copyright

  [ Ondřej Nový ]
  * debian/copyright: Use https protocol in Format field

 -- Philip Rinn <rinni@inventati.org>  Mon, 26 Nov 2018 22:32:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: gimagereader
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Philip Rinn <rinni@inventati.org>
+Maintainer: Philip Rinn <rinni@inventati.org>
 Build-Depends:
  cmake,
- debhelper (>= 10),
+ debhelper (>= 11),
  intltool (>= 0.35.0),
  libcairomm-1.0-dev,
+ libdjvulibre-dev,
  libgtkmm-3.0-dev,
  libgtksourceviewmm-3.0-dev,
  libgtkspellmm-3.0-dev (>= 3.0.4),
@@ -19,7 +19,10 @@
  libsane-dev,
  libtesseract-dev,
  libxml++2.6-dev,
-Standards-Version: 4.1.3
+ libzip-dev,
+ python3-gi,
+ uuid-dev,
+Standards-Version: 4.2.1
 Homepage: https://github.com/manisandro/gImageReader
 Vcs-Git: https://salsa.debian.org/debian/gimagereader.git
 Vcs-Browser: https://salsa.debian.org/debian/gimagereader
